#ifndef BABY_PLUGIN_DEFINE_H_
#define BABY_PLUGIN_DEFINE_H_
#include "baby_plugin_types.h"
/*
BabyImageEntry:עĽṹ
utils:ṩһЩ볣
info:践صĹڲһЩϢ,,,֧OPEN,֧SAVE,.
open_s:֧OPENĲҪص.ҪЩ,οBabyOpenCallback˵
save_s:֧SAVEĲҪص,ҪЩ,οBabySaveCallback˵
effective:֧ЧĲҪص,ҪЩ,οBabyEffectiveCallback˵
extra_s:ռλ,ò,չ.
*/

typedef struct _Baby_Plugin_Load
{
	BabyUtilities			utils;
	BabyInformation			info;
	BabyOpenCallback		open_s;
	BabySaveCallback		save_s;
	BabyEffectiveCallback	effective;
	BabyExtra				extra_s;//for future use.
}BabyImageEntry;


/*
get_scale_num:ȡͼڱֳµű
w:ԭͼ
h:ԭͼ߶
dw:Ŀ
dh:ĸ߶
ֵ:ڱ֤ͼĳ,dw,dhű.
:w=100,h=200,dw=50,dh=50,
ʺϵͼߴΪ25*50,4
*/
inline UINT
get_scale_num(UINT w,UINT h,UINT dw,UINT dh)
{/**/
	UINT tw,th;
	tw=w/dw;
	if(w%dw)tw++;
	th=h/dh;
	if(h%dh)th++;
	return (tw>th)?tw:th;
}
/**/
static inline const char*
bby_get_extension(const char*file)
{
	const char*pos=NULL;
	if(file==NULL)return NULL;
	while((file=strchr(file+1,'.')))
	{
		pos=file+1;
		file--;
		if(file[0]=='/')pos=NULL;
		file++;
	}
	return pos;
}

/*
my_strdup:һִ,extӵfile
file:ļ
ext:ӵչ
ֵ:һfile+extִ,߸freeڴ
:char*rev=my_strdup("/root/a.bmp","jpg");
rev:/root/a.bmp.jpg
(Ǻ,еɵ,ƺӦð.bmpȥ)
:free(rev);
*/
inline char*
my_strdup(const char*file,const char*ext)
{
	int len=strlen(file);
	char*f=(char*)malloc(len+strlen(ext)+5);
	if(f==NULL)return NULL;
	memcpy(f,file,len);
	f[len]=0;
	const char*se=bby_get_extension(f);
	if(se&&strcasecmp(se,ext)==0)return f;
	f[len++]='.';
	strcpy(f+len,ext);
	return f;
}
/*
get_color:ȡָصĳһɫ(ɫɫɫ)
x:X
y:Y
img:ͼ
which:0,ɫ,1,ɫ,2,ɫ
ֵ:ָصָɫ,0255
*/
inline int
get_color(int x,int y,const BabyOneImage*img,int which)//which:0,red,1,green,2,blue
{//for better performance,no check for img,it should be done yourself.
	int pos=y*img->rgb_width*3+x*3+which;
	return ((int)img->rgb_data[pos])&0xFF;
}
/*
get_color_rgb:ȡָصɫ(һֵз)
x:X
y:Y
img:ͼ
ֵ:ָصɫֵ,0-0xFFFFFF,
:0x345678,0x34ʾɫ,0x56ʾɫ,0x78ʾɫ)
*/
inline int
get_color_rgb(int x,int y,const BabyOneImage*img)
{
	int pos=y*img->rgb_width*3+x*3;
	int rgb;
	rgb=img->rgb_data[pos++];
	rgb<<=8;
	rgb|=img->rgb_data[pos++];
	rgb<<=8;
	rgb|=img->rgb_data[pos];
	rgb&=0xFFFFFF;
	return rgb;
}
#define get_red_color(x,y,img) get_color(x,y,img,0)
#define get_green_color(x,y,img) get_color(x,y,img,1)
#define get_blue_color(x,y,img) get_color(x,y,img,2)
/*
set_color:ָصָɫ
value:ɫֵ
x:X
y:Y
img:ͼ
which:ָɫ,0,ɫ,1,ɫ,2,ɫ
޷ֵ.
*/
inline void
set_color(int value,int x,int y,const BabyOneImage*img,int which)//which:0,red,1,green,2,blue
{//for better performance,no check for img,it should be done yourself.
	int pos=y*img->rgb_width*3+x*3+which;
	img->rgb_data[pos]=(UCHAR)value;
}
/*
set_color_rgb:ָصɫ
value:ɫֵ,:0x345678,0x34Ϊɫֵ,0x56Ϊɫֵ,0x78Ϊɫֵ
x:X
y:Y
img:ͼ
޷ֵ.
*/
inline void
set_color_rgb(int value,int x,int y,const BabyOneImage*img)
{
	int pos=y*img->rgb_width*3+x*3+2;
	img->rgb_data[pos--]=(UCHAR)value;
	value>>=8;
	img->rgb_data[pos--]=(UCHAR)value;
	value>>=8;
	img->rgb_data[pos]=(UCHAR)value;
}
#define set_red_color(v,x,y,img) {set_color(v,x,y,img,0);}
#define set_green_color(v,x,y,img) {set_color(v,x,y,img,1);}
#define set_blue_color(v,x,y,img) {set_color(v,x,y,img,2);}
/*
is_mask_color:ڶBabyOneImagemaskcolorԱж
cl:BabyOneImagemaskcolor
ֵ:MaskColor(͸ɫ)TRUE,,򷵻FALSE.
*/
inline bool
is_mask_color(BabyColor*cl)
{
	return (cl->r!=255&&cl->g!=255&&cl->b!=255);
}

#define BABY_DEFAULT_PLUGIN "default.bby"
#define BABY_BLANK_PLUGIN "blank.bby"
#define BABY_ENTRY	"BabyBorn"
/*
:
1,ÿһֻ뵼һΪBabyBornĺ,ԭΪ:typedef int (*BabyBorn)(BabyImageEntry*);
2,ṩõĺ,зֵ,򷵻ֵΪ0ʾʧ,ֵΪ0ʾóɹ.ڴ0С0,Ӿ庯
3,ظڴ,getmemory,ڴһظ,ʹ,Ҳͷ
4,ĳһgetmemoryڴ,պʧ,Ըڴfreememory
5,οbaby_plugin_types.h
*/
#endif	//BABY_PLUGIN_DEFINE_H_



