#ifndef BABYSEE_PLUGIN_TYPES_H_
#define BABYSEE_PLUGIN_TYPES_H_
#define RET	/*ʾɲ*/
#define IN	/*ʾṩ*/
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <X11/Xlib.h>

#ifndef UINT
#define UINT	unsigned int
#endif
#ifndef UCHAR
#define UCHAR	unsigned char
#endif
typedef struct _Baby_Color
{
	int	r,g,b;//r,ɫ,g,ɫ,bɫ
	int	zero;//δ
}BabyColor;

/*
BabyOneImage:һͼ,ҪŪ
R:ɫ
G:ɫ
B:ɫ
*/
typedef struct _Baby_One_Image
{
	/*
	rgb_width:ͼʾĿ
	rgb_height:ͼʾĸ߶
	rgb_data:ͼ,,ڴзʽΪRGBRGBRGBRGB.
	Ϊx,yصɫֵΪ:ɫ(rgb_data[y*rgb_width*3+x*3]),ɫ(rgb_data[y*rgb_width*3+x*3+1]),ɫ(rgb_data[y*rgb_width*3+x*3+2])
	,x,y0ʼ,:0<=x<rgb_width, 0<=y<rgb_height.	
	image_width:ͼļĿ
	image_height:ͼļĸ߶
	rgb_width,rgb_heightimage_width,image_heightǲͬ,
	rgb_width,rgb_heightǲʵʷصͼС,rgb_data,
	image_width,image_heightǴϵļͼС
	*/
	UCHAR*		rgb_data;RET	//the image data,see follow rgb_data format for more
	UINT		rgb_width;RET	//the width of returned image.if the returned image is scaled,rgb_width is the scaled width.
	UINT		rgb_height;RET	//the height of returned image.if the returned image is scaled,rgb_height is the scaled height
	UINT		image_width;RET	//the width of image.if the returned image is scaled,image_width is the width before scale.so,if not scaled,image_width=rgb_width.
	UINT		image_height;RET	//the height of image,if the returned image is scaled,image_height is the height before scale.so,.......
	/*
	image_bpp:ͼλ,
	mask_color:ͼ͸ɫ,ͼ񲻾߱͸ɫ,0
	*/
	UINT		image_bpp;RET	//bpp of image.such as 1<<8,1<<16,1<<24,etc.set to zero for no information.
	BabyColor	mask_color;RET	//mask color of each image.if no mask color is defined for image,set to zero.	
	/*³Աδ,ʹ,ʹ*/
	UCHAR*		now_reserved1;	//do not use this two field,it's for future use,
	UINT		now_reserved2;	//if you want to store your private information,use next two fields.
	/*³Աʹ,򲻸*/
	UCHAR*		user_data;	//i won't use this two field,it's for your use,enjoy yourself here.
	UINT		user_value;		
}BabyOneImage;
/*example;
//suppose there's an image size 800*600,and we have scaled it to 40*30
//image's mask color is [80,100,255]
BabyOneImage*bb=(BabyOneImage*)get_memory(sizeof(BabyOneImage));
bb->image_width=800;
bb->image_height=600;
bb->rgb_width=40;
bb->rgb_height=30;
bb->rgb_data=(UCHAR*)get_memory(40*30*3);	//oh,because one pixel need 3bytes,so we should allocate 40*30*3bytes.
bb->mask_color={80,100,255};
NOTE:
you should allocate rgb_data by get_memory provided by main programe.
the rgb_data is freed by main programe,so there's no need to free rgb_daga in plugin.
*/

/*
BabyImage:ظͼ
*/
typedef struct _Baby_Image
{
	/*
	reload:0,ʾʹл,Ҳ´Ӵ̼ļ.òʱָ
	num_images:ṹnum_images̬ͼ(BabyOneImage),0<num_images<MAX_BABYS
	wparam,lparam:
	1,num_images==1:0
	2,num_images>1&&num_images<MAX_BABYS:
			wparam0,ôᵥʾÿһBabyOneImage,
			wparam0,ᰴlparam趨ļ̬лÿһBabyOneImage,Ƴ֧GIF89Aȵ
	3,num_images==0x7FFFFFFF:
			wparamʾһDrawable,lparamʾڶwparamòüDrawable
	*/
	UINT			reload;	IN	//if reload is not zero,you should do reload the image from disk.
	UINT			num_images;RET		//how much images.
	UINT			wparam;RET		//see follow for more.
	UINT			lparam;RET		//see follow for more.
	/*
	image:ͼ,μBabyOneImage˵,num_images>=MAX_BABYS,imageΪNULL
	*/
	BabyOneImage*	image;RET		//BabyOneImage[num_images];
//-----------------------------------------------------------------------------
	UCHAR*			now_inuse1;
	UCHAR*			now_inuse2;
	UINT			now_reserved1;
	UINT			now_reserved2;
	UINT			now_reserved3;
	UINT			now_reserved4;
//-------------------------------------------------------------------------------	
	UCHAR*			user_data;
	UINT			user_value;
//-----------------------------------------------------------------------------------
}BabyImage,*PBABYIMAGE;
#define MAX_BABYS		0x7FFFFFFE

/*
NOTE:
you should allocate image by get_memory provided by main programe.	
there's no need to free image,because main programe will free them automaticlly.
*/

/*
BabyOptions:ڵShowOptions,Ǻ,.
*/
#define OPT_LEN	128
typedef struct _Baby_Save_Options
{
	UINT			Options;
	char			OptionText1[OPT_LEN];
	char			OptionData1[OPT_LEN+1];
	char			OptionText2[OPT_LEN];	
	char			OptionData2[OPT_LEN+1];
	char			OptionText3[OPT_LEN];
	char			OptionData3[OPT_LEN+1];
	char			OptionText4[OPT_LEN];
	int				OptionData4;
	char			OptionText5[OPT_LEN];
	int				OptionData5;
}BabyOptions;
#define	BabyOption1				1<<0
#define BabyOption2				1<<1
#define BabyOption3				1<<2
#define BabyOption4				1<<3
#define BabyOption5				1<<5
#define BabyOptionAll				(BabyOption1|BabyOption2|BabyOption3|BabyOption4|BabyOption5)

inline void
zero_options(BabyOptions*op)
{
	if(op)
	{
		memset(op->OptionData1,0,OPT_LEN);
		memset(op->OptionData2,0,OPT_LEN);
		memset(op->OptionData3,0,OPT_LEN);
		op->OptionData4=0;
		op->OptionData5=0;		
	}
}
//--the following are the functions provided by main programe to help you.
typedef void*		(*GetMemory)(UINT size);
typedef void		(*FreeMemory)(void*);
typedef void		(*LockX)(void*);
typedef void		(*UnlockX)(void*);
typedef int			(*ShowOptions)(const char*,BabyOptions*,int);
typedef int			(*ShowMessage)(const char*caption,const char*text,int button);
typedef int			(*GetInteger)(const char*caption,const char*text,int*value,int min,int max,int step);
typedef int			(*GetText)(const char*caption,const char*text,char*value,int len,const char*defaulttext);
#define				MB_YES		1<<2
#define				MB_NO		1<<3
#define				MB_OK		1<<4
#define				MB_CANCEL	1<<5
#define				MB_RETRY	1<<6
#define				MB_IGNORE	1<<7
#define				MB_YESNO	MB_YES|MB_NO
#define				MB_OKCANCEL	MB_OK|MB_CANCEL
//the following is to set messagebox icon.they can be or'ed with button.
#define				MB_ICONINFORMATION	1<<10
#define				MB_ICONQUESTION		1<<11
#define				MB_ICONCRITICAL		1<<12
//
#define				MB_MODAL			1<<20
//the following is the return value.
#define				IDERROR		0
#define				IDYES		1
#define				IDNO		2
#define				IDRETRY		3
#define				IDIGNORE	4
#define				IDOK		IDYES
#define				IDCANCEL	IDNO

/*
ڵStepShow,ƳڲͼƬĹ,
̬,ӶԱȽѺõķʽʵֶԴͼƬļ,
ϧĿǰδʵStepShow
ĻϽΪԭ
order:
STEP_ORDER_DOWN:ʾͼļعΪϵ
STEP_ORDER_UP:ʾͼļعΪµ
x:
w:
y:
h:
xw,yhɼ
*/
#define				STEP_ORDER_ALL	0
#define 			STEP_ORDER_DOWN	1
#define				STEP_ORDER_UP	2
typedef struct tagStep
{
	int				order;
	int				x;//start column
	int				w;//end column
	int				y;//start row
	int				h;//end row	
}Step;
/*
DoSupport:ṩ,жϸòǷ֧Ӧļļ
file:ļ
ext:չ
magic:ΪNULL,ʾѶȡļͷϢ,ͨΪNULL
len:magicΪNULL,Ϊmagicݳ
option:ѡ,Ŀǰδʹ,0
ֵ:ָ֧øʽļ,ط0,򷵻0
*/
typedef int			(*DoSupport)(const char*file,const char*ext,UCHAR*magic,UINT len,int option);
/*
LoadPreview:ṩ,ڼĳһͼļԤ
file:ͼļ
bb:ڴ˷ͼ,BabyImage
dw:ڴĿ
dh:ڴĸ߶
ѡbaby_plugin.hеget_scale_numȡӦű
option:ѡ,Ŀǰδʹ,0
ֵ:ɹɼ,ط0,򷵻0
*/
typedef int			(*LoadPreview)(const char*file,BabyImage*bb,UINT dw,UINT dh,int option);
/*
LoadImage:ṩ,ڼͼļʾ
file:ͼļ
bb:ڴ˷ͼ,BabyImage
ѡbaby_plugin.hеget_scale_numȡӦű
option:ѡ,Ŀǰδʹ,0
ֵ:ɹɼ,ط0,򷵻0
*/
typedef int			(*LoadImage)(const char*file,BabyImage*bb,int option);
/*
StepShow:ṩ,ڶ̬ʾع
bb:Բڼصͼ
s:ͼѼزֵ
ֵ:0ʾ
ע:ĿǰֻǼ򵥵ķ1.
*/
typedef int			(*StepShow)(const BabyOneImage*bb,const Step*s);
/*
FreeImage:ṩ,Ҫȡĳͼݵʱ
bb:ͼ
ֵ:0ʾɹ,0ʾʧ.
ע:rgb_data,BabyImage->BabyOneImage*ЩԴ,Ḻͷ,ҪͷŵԴ.
ûҪرͷŵԴ,򵥵ķ1.
*/
typedef int			(*FreeImage)(BabyImage*bb);
/*
WillSave:ṩ,жϲǷֽ֧ͼ񱣴ΪӦʽ
file:ļ,/root/a.jpg
ext:չ,:jpg
ֵ:0ʾ֧.
*/
typedef int			(*WillSave)(const char*file,const char*ext);
/*
SaveImage:ṩ,ڱͼƬ
file:Ŀļ
ext:չ
bb:ͼݵ
bbs:ѡ,ΪNULL,ʹôѡ.
bbsΪNULL(ͨ),о.
ѯû,ʹṩgetinteger,gettext,showoptionsȹ
ֵ:0ʾɹ.
*/
typedef int			(*SaveImage)(const char*file,const char*ext,const BabyImage*bb,const BabyOptions*bbs);
/*
EffectiveImage:ṩ,ýĳЧ
bb:ͼݵ
bes:ѡ,ΪNULL,ʹôѡ.besΪNULL(ͨ),о.
tag:Чڲе,ڼʱɲ,ͬBabyEffectiveеtag,μBabyEffective
canresize:canresizeΪ0,޸rgb_dataָ,,ǿ޸ָ
canresizeΪ0,޸rgb_dataָ,,,MMMMMM,޸rgb_dataָ,Ҫǵͬʱ޸rgb_width,rgb_heightŶ.
ֵ:0ʾɹ.
*/
typedef int			(*EffectiveImage)(BabyImage*bb,const BabyOptions*bes,int tag,int canresize);

/*
BabyEffective:ڶһЧ
*/
typedef struct _Baby_Effective_Unit
{
	const char			*name;//Ч,һṩöЧ,ҪÿһЧȡŶ.
	EffectiveImage		do_effective;//Чʵʴ
	/*
	tag:Чڱе,0ʼ,ڵdo_effectiveʱҪ,ͨͬһṩͬЧ
	:һṩ5Ч,tagΪ:0,1,2,3,4
	*/
	int					tag;
	BabyOptions			option;//plugin developer use this struct.if not use,set option.Options=0
}BabyEffective;

/*BabyExtra:ռһԴ,չһЩ*/
typedef struct tagBabyExtra
{
	void				*extra0;
	void				*extra1;
	UINT				extra2;
	UINT				extra3;
}BabyExtra;

typedef struct tagBabyUtilities
{
	UINT				hello1;IN
	UINT				hello2;IN
	Display				*display;IN
	int					screen;IN
	Window				window;IN
	UINT				depth;IN
	LockX				lock_x;IN
	UnlockX				unlock_x;IN
	GetMemory			get_memory;IN
	FreeMemory			free_memory;IN
	ShowOptions			show_options;IN
	ShowMessage			show_message;IN
	GetInteger			get_integer;IN
	GetText				get_text;IN
	StepShow			step_show;IN
	const char			*language;
	BabyExtra			extra;
}BabyUtilities;
typedef struct tagBabyInformation
{
	const char			*plug_name;	RET
	const char			*discription;RET
	const char			*author;RET
	const char			*copyright;RET
	const char			**open_information;RET	//should end by a NULL char*
	const char			**save_information;RET	//should end by a NULL char*
	BabyExtra			extra;
}BabyInformation;
typedef struct tagBabyOpenCallback
{
	DoSupport			do_support;RET
	LoadPreview			load_preview;RET
	LoadImage			load_image;RET
	FreeImage			free_image;RET	
	BabyExtra			extra;
}BabyOpenCallback;
typedef struct tagBabySaveCallback
{
	WillSave			can_you_save;RET
	SaveImage			save_image;RET	
	BabyExtra			extra;
}BabySaveCallback;
typedef struct tagBabyEffectiveCallback
{
	const char*			effective_name;RET
	UINT				effective_count;RET
	BabyEffective		*effective;RET	
	BabyExtra			extra;
}BabyEffectiveCallback;
#endif


