#ifdef __cplusplus
extern "C" 
{
#endif
#include <baby_plugin.h>
#include <time.h>

void _init();
void _fini();
//-----the following is the callback for main programe
//-----NOTE:i defined them static,because there's no need to call outside,i just provide the function pointer to main programe.
	
static int demo_effective(BabyImage*bb,const BabyOptions*op,int tag,int canresize);//darker,lighter effect
static int invert_image(BabyImage*bb,const BabyOptions*op,int tag,int canresize);//invert image color
static int flip_image(BabyImage*bb,const BabyOptions*op,int tag,int canresize);
static int rotate_image(BabyImage*bb,const BabyOptions*op,int tag,int canresize);	
static int scale_image(BabyImage*bb,const BabyOptions*op,int tag,int canresize);
static GetMemory	get_memory=NULL;
static FreeMemory	free_memory=NULL;
static LockX		lock_x=NULL;
static UnlockX		unlock_x=NULL;
static ShowOptions	show_options=NULL;
static ShowMessage	show_message=NULL;
static GetInteger	get_integer=NULL;
	
static BabyEffective	my_effective[12];
static UINT				my_effectivecount=12;
static const char*		my_query;
static const char*		my_queryscalew,*my_queryscaleh;
//--------------------------------------------------------------------
int
BabyBorn(BabyImageEntry*bb)
{
	get_memory=bb->utils.get_memory;
	free_memory=bb->utils.free_memory;
	lock_x=bb->utils.lock_x;
	unlock_x=bb->utils.unlock_x;
	show_options=bb->utils.show_options;
	show_message=bb->utils.show_message;
	get_integer=bb->utils.get_integer;
	
	if(bb->utils.language&&strcasecmp(bb->utils.language,"gbk")==0)
	{
		bb->info.plug_name="ʾ";
		bb->info.discription="Babyseeʾʾ";
		bb->info.author="walk_in_sky  falconinsky";
		bb->info.copyright="";
		bb->effective.effective_name="Ч";		
		my_effective[0].name="ͼɫ";
		my_effective[1].name="˺ɫ";
		my_effective[2].name="ɫ";
		my_effective[3].name="ɫ";
		my_effective[4].name="޸ĺɫ";
		my_effective[5].name="޸ɫ";
		my_effective[6].name="޸ɫ";
		my_effective[7].name="ˮƽת";
		my_effective[8].name="ֱת";
		my_effective[9].name="ת";
		my_effective[10].name="ת";
		my_effective[11].name="ͼ";
		my_query="ָҪ޸ĵĶ\n(-255255֮䣬ʾ䰵ʾ)";
		my_queryscaleh="µĸ߶(Ϊλ):";
		my_queryscalew="µĿ(Ϊλ):";
	}
	else
	{
		bb->info.plug_name="Demo Plugin";
		bb->info.discription="Babysee Demo plugin.Just for demo.";
		bb->info.author="walk_in_sky & falconinsky.";
		bb->info.copyright="Freeware.";
		bb->effective.effective_name="Demo";
		my_effective[0].name="Invert Image";
		my_effective[1].name="Ignore Red";
		my_effective[2].name="Ignore Green";
		my_effective[3].name="Ignore Blue";
		my_effective[4].name="Modify Red";
		my_effective[5].name="Modify Green";
		my_effective[6].name="Modify Blue";
		my_effective[7].name="Flip Horizontal";
		my_effective[8].name="Flip Vertical";
		my_effective[9].name="Rotate 90C";
		my_effective[10].name="Rotate -90C";
		my_effective[11].name="Scale Image";
		my_query="Specify the degree you want to modify:(range from -255 to 255)";
		my_queryscaleh="Please Sepcify New Height(in pixel):";
		my_queryscalew="Please Sepcify New Width(in pixel):";
	}	

	bb->effective.effective_count=my_effectivecount;
	my_effective[0].tag=0;
	my_effective[0].do_effective=invert_image;
	for(UINT i=1;i<7;i++)
	{
		my_effective[i].tag=i;//set tag to index of effective in the plugin,it's necessary.
		my_effective[i].do_effective=demo_effective;//set the same function,hehe,you can use tag to decide which effective.
	}
	my_effective[7].tag=7;
	my_effective[7].do_effective=flip_image;
	my_effective[8].tag=8;
	my_effective[8].do_effective=flip_image;
	my_effective[9].tag=9;
	my_effective[9].do_effective=rotate_image;
	my_effective[10].tag=10;
	my_effective[10].do_effective=rotate_image;
	my_effective[11].tag=11;
	my_effective[11].do_effective=scale_image;
	
	bb->effective.effective=my_effective;
	
	return (get_memory&&free_memory)?1:0;//if you want to use Xlib,please check lock_x and unlock_x
}
//-----------------------------------------------------------------------------------------------------
void _init()
{
	
}
void _fini()
{
	
}

int
demo_effective(BabyImage*bb,const BabyOptions*op,int tag,int canresize)
{
	if(!bb||!bb->image||!bb->image->rgb_data||!canresize)return 0;
	UCHAR*data=bb->image->rgb_data;
	int len=bb->image->rgb_width*bb->image->rgb_height*3;
	if(len<=0)return 0;
	if(tag==1||tag==2||tag==3)
	{//ignore red
		tag--;//
		for(int i=0;i<len;i+=3)
		{
			data[i+tag]=0;//set specified color to zero,so ignored,hehe
		}
		return 1;//success return
	}
	else if(tag==4||tag==5||tag==6)
	{
		tag-=4;
		int mod=25;
		int temp;
		if(get_integer(my_effective[tag].name,my_query,&mod,-255,255,2)==0)return 0;
		for(int i=0;i<len;i+=3)
		{
			temp=((int)data[i])&0xFF;
			temp+=mod;
			if(temp>0xFF)
				data[i+tag]=0xFF;
			else if(temp<0)
				data[i+tag]=0;
			else
				data[i+tag]=(UCHAR)temp;
		}
		return 1;
	}
	return 0;
}

int
invert_image(BabyImage*bb,const BabyOptions*op,int tag,int canresize)
{
	if(!bb||!bb->image||!bb->image->rgb_data||!canresize)return 0;
	int value;
	for(UINT y=0;y<bb->image->rgb_height;y++)
	{
		for(UINT x=0;x<bb->image->rgb_width;x++)
		{
			value=((255-get_red_color(x,y,bb->image))<<16)|((255-get_green_color(x,y,bb->image))<<8)|(255-get_blue_color(x,y,bb->image));
			set_color_rgb(value,x,y,bb->image);
		}
	}
	return 1;
}
int
flip_image(BabyImage*bb,const BabyOptions*op,int tag,int canresize)
{
	if(!bb||!bb->image||!bb->image->rgb_data||!canresize)return 0;
	int w=bb->image->rgb_width,h=bb->image->rgb_height;
	unsigned char  *ptr1,
				   *ptr2,
					r,
					rr;
	int             x,
					y;
	int             w3;
	if(tag==7)
	{//flip horzitotal	
		w3 = w * 3;
		for (y = 0; y < h; y++) 
		{
			ptr1 = bb->image->rgb_data + (y * w3);
			ptr2 = bb->image->rgb_data + (y * w3) + w3 - 3;
			for (x = 0; x < w >> 1; x++) 
			{
				r = *ptr1;
				rr = *ptr2;
				*ptr2++ = r;
				*ptr1++ = rr;
				r = *ptr1;
				rr = *ptr2;
				*ptr2++ = r;
				*ptr1++ = rr;
				r = *ptr1;
				rr = *ptr2;
				*ptr2 = r;
				*ptr1++ = rr;
				ptr2 -= 5;
			}
		}
		return 1;
	}
	else if(tag==8)
	{//flip vertical
		int yy;
	    w3 = w * 3;
    	for (yy = h - 1, y = 0; y < h >> 1; y++, yy--) 
		{
			ptr1 = bb->image->rgb_data + (y * w3);
			ptr2 = bb->image->rgb_data + (yy * w3);
			for (x = 0; x < w; x++) 
			{
				r = *ptr1;
				rr = *ptr2;
				*ptr2++ = r;
				*ptr1++ = rr;
				r = *ptr1;
				rr = *ptr2;
				*ptr2++ = r;
				*ptr1++ = rr;
				r = *ptr1;
				rr = *ptr2;
				*ptr2++ = r;
				*ptr1++ = rr;
			}
		}
		return 1;	
	}
	return 0;
}
int
rotate_image(BabyImage*bb,const BabyOptions*op,int tag,int canresize)
{
	if(!bb||!bb->image||!bb->image->rgb_data||!canresize)return 0;
    UCHAR			*data;
    int             x,
					y,
					w3,
					w4,
					w,h;
    UCHAR			*ptr1,
					*ptr2;

	w = bb->image->rgb_width;
	h = bb->image->rgb_height;
    w3 = w * 3;
    w4 = h * 3;
    data =(UCHAR*)get_memory(w*h*3);
    if (data == NULL)return 0;
    for (y = 0; y < h; y++) 
	{
		ptr1 = bb->image->rgb_data + (y * w3);
		ptr2 = data + (y * 3);
		for (x = 0; x < w; x++) 
		{
			*ptr2++ = *ptr1++;
			*ptr2++ = *ptr1++;
			*ptr2 = *ptr1++;
			ptr2 += w4 - 2;
		}
	}
    free_memory(bb->image->rgb_data);
    bb->image->rgb_data = data;
	bb->image->rgb_width = h;
	bb->image->rgb_height = w;
	if(tag==10)return flip_image(bb,NULL,7,1);
	return 1;
}
int
scale_image(BabyImage*bb,const BabyOptions*op,int tag,int canresize)
{
	if(!bb||!bb->image||!bb->image->rgb_data||!canresize)return 0;
	int w=bb->image->rgb_width,h=bb->image->rgb_height;
	UCHAR*sdata=NULL;//scaled image data
	/*use get_integer to query user what's new height width*/
	if(get_integer(my_effective[11].name,my_queryscalew,&w,1,bb->image->rgb_width*10,1)==0||w<=0)return 0;
	if(get_integer(my_effective[11].name,my_queryscaleh,&h,1,bb->image->rgb_height*10,1)==0||h<=0)return 0;
	if((UINT)w==bb->image->rgb_width&&(UINT)h==bb->image->rgb_height)return 1;
	sdata=(UCHAR*)get_memory(w*h*3);
	if(sdata==NULL)return 0;
	//now,start to scale image
	int				x,
					y,
					*xarray;
	unsigned char **yarray,
					*ptr,
					*ptr2,
					*ptr22;
	int				inc,
					pos,
					w3;

	xarray = (int *) malloc(sizeof(int) * w);
	if (xarray==NULL)
	{
		free_memory(sdata);
		return 0;
	}
	yarray = (UCHAR**) malloc(sizeof(UCHAR*) * h);
	if (yarray==NULL)
	{
		free(xarray);
		free_memory(sdata);
	    return 0;
	}
	ptr22 = bb->image->rgb_data;
	w3 = bb->image->rgb_width * 3;
	inc=(bb->image->rgb_width<<16)/w;
	pos=0;
	for (x = 0; x < w; x++) 
	{
		xarray[x] = (pos >> 16) + (pos >> 16) + (pos >> 16);
		pos += inc;
	}

	pos = 0;
	inc=(bb->image->rgb_height<<16)/h;
	for (x = 0; x < h; x++) 
	{
		yarray[x] = ptr22 + ((pos >> 16) * w3);
		pos += inc;
	}
	
	ptr = sdata;
	for (y = 0; y < h; y++) 
	{
	    for (x = 0; x < w; x++) 
		{
			ptr2 = yarray[y] + xarray[x];
			*ptr++ = (int) *ptr2++;
			*ptr++ = (int) *ptr2++;
			*ptr++ = (int) *ptr2;
	    }
	}
	free(xarray);
	free(yarray);
	free_memory(bb->image->rgb_data);
	bb->image->rgb_data=sdata;
	bb->image->rgb_width=w;
	bb->image->rgb_height=h;
	return 1;
}
#ifdef __cplusplus
}
#endif
